
'---------------------
'co2 o2 compiler maker
'=====================

'Charles Pegge
'Revised: 22:14 10 Sept 2010

  #basic


  '------------
  'SELECTED API
  '============
  '
  extern stdcall lib "oxygen.dll"

  declare sub      o2_asmo  (byval s as string)
  declare sub      o2_basic (byval s as string)
  declare function o2_buf   (byval n as long) as long
  declare function o2_errno () as long
  declare function o2_error () as string
  declare function o2_exec  (optional byval p as long) as long
  declare function o2_get   () as string
  declare function o2_len   () as long
  declare function o2_prep  (byval srcBSTR as string) as string
  declare sub      o2_put   (byval c as string)
  declare function o2_view  (byval srcBSTR as string) as string

  end extern

  DECLARE FUNCTION GetCommandLine LIB `KERNEL32.DLL` ALIAS `GetCommandLineA` () AS ASCIIZ PTR
  
  string z 
  
  z=GetCommandLine

  dim a as long
  dim n,s,t,u as string
  dim as string qu=chr(34)
  dim as string cr=chr(13)+chr(10)
  '
  n=ltrim lcase z
  '
  'SKIP COMMAND
  '
  a=asc(n)
  b=1
  if a=34 then
    b=instr(2,n,qu)
    b+=1
  end if
  '
  '
  'CHECK FOR PARAMETER FOLLOWING
  '
  a=instr(b,n,` `)
  if not a then
    print `error 1: missing filename`
    goto finish
  end if
  '
  '
  if not len(n) then
    print `error 2: missing filename`
    goto finish
  end if
  '
  n=mid n,a+1
  n=ltrim(n)
  '
  'STRIP QUOTES ON FILENAME
  '------------------------
  '
  if asc(n)=34 then
    b=instr(2,n,qu)
    if b then n=mid n,2,b-2
  end if
  '
  'CHECK FOR .BAS EXTENSION NAME
  '
  n=rtrim n
  s=mid n,-4,4
  if s=`.bas` then
    s=n
  elseif s=`2bas` then
    s=n
  else
    s=n+`.bas`
  end if
  '
  'ATTEMPT TO GET FILE
  '-------------------
  '
  t=getfile s
  if not len(t) then
    print `error 3: file empty or not found: ` s
    goto finish
  end if

  '
  'create exe name
  '
  a=1 : b=0
  '
  do
    a=instr(a,s,".")
    if a then b=a else exit do
    inc a
  end do
  '
  if b then s=left s,b
  '
  t="#basic" cr "#file " qu s "exe" qu cr t

  o2_asmo t

  if o2_errno then
    print `error:
    ` o2_error
  else
    print `compiled: ` n
  end if


  finish:
  '------
  
