
'---------------------
'co2 o2 compiler maker
'=====================

'Charles Pegge
'21 June 2010
'10 Sept 2010

  #basic
  #file `eo2.exe`

  dim as string cr =chr(13)+chr(10)

  
  '------------
  'SELECTED API
  '============
  '

  library `oxygen.dll`
  declare sub      o2_mode  (byval m as long)
  declare sub      o2_asmo  (byval s as string)
  declare sub      o2_basic (byval s as string)
  declare function o2_exec  (optional byval addr as long) as long
  declare function o2_buf   (byval n as long) as long
  declare function o2_error () as string
  declare function o2_get   () as string
  declare function o2_len   () as long
  declare function o2_prep  (byval srcBSTR as string) as string
  declare sub      o2_put   (byval c as string)
  declare function o2_view  (byval srcBSTR as string) as string

  library `kernel32.dll`

  declare FUNCTION GetCommandLine ALIAS `GetCommandLineA` () AS DWORD

/*

  library "KERNEL32.DLL"
  declare FUNCTION AllocConsole    ALIAS "AllocConsole" () AS LONG
  declare FUNCTION GetStdHandle    ALIAS "GetStdHandle" (BYVAL handle AS DWORD) AS DWORD
  declare FUNCTION WriteConsole    ALIAS "WriteConsoleA" (BYVAL hConsoleOutput AS DWORD, lpBuffer AS ASCIIZ, BYVAL nNumberOfCharsToWrite AS LONG, lpNumberOfCharsWritten AS LONG, BYVAL lpReserved AS LONG) AS LONG
  declare FUNCTION ReadConsole     ALIAS "ReadConsoleA" (BYVAL hConsoleInput AS DWORD, BYVAL lpBuffer AS DWORD, BYVAL nNumberOfCharsToRead AS LONG, lpNumberOfCharsRead AS LONG, pInputControl AS ANY) AS LONG
  declare FUNCTION SetConsoleTitle ALIAS "SetConsoleTitleA" (lpConsoleTitle AS ASCIIZ) AS LONG

  %STD_INPUT_HANDLE  = -10
  %STD_OUTPUT_HANDLE = -11
  %STD_ERROR_HANDLE  = -12


  'AllocConsole

  dim consIn AS LONG,consOut AS LONG,consErr AS LONG

  ConsIn =GetStdHandle (%STD_INPUT_HANDLE)
  ConsOut=GetStdHandle (%STD_OUTPUT_HANDLE)
  ConsErr=GetStdHandle (%STD_ERROR_HANDLE)

  dim bufout as string
  dim bufin  as string
  dim buflen
  dim bufrit

  dim as string tab=chr 9

  bufin=nuls 1000


' BOOL WINAPI WriteConsole(
'   __in        HANDLE hConsoleOutput,
'   __in        const VOID *lpBuffer,
'   __in        DWORD nNumberOfCharsToWrite,
'   __out       LPDWORD lpNumberOfCharsWritten,
'   __reserved  LPVOID lpReserved
' );


' BOOL WINAPI ReadConsole(
'   __in      HANDLE hConsoleInput,
'   __out     LPVOID lpBuffer,
'   __in      DWORD nNumberOfCharsToRead,
'   __out     LPDWORD lpNumberOfCharsRead,
'   __in_opt  LPVOID pInputControl
' );


  SetConsoleTitle "Oxygen BASIC Compiler"



  'PRINT OVERRIDE FOR CONSOLE OUTPUT

  '-------------------------------------
  'function print(s as string)
  '=====================================
  '  bufout=s+cr
  '  buflen=len(bufout)
  '  WriteConsole ConsOut,bufout,buflen,bufrit,0
  'end function

*/

  library ""
  
  dim byref z as zstring  
  &z=GetCommandLine

  'print `Commandline: ` z
  
  dim a,b,e
  dim n,s,t as string
  dim as string qu=chr 34
  dim as string tab=chr 9
  '
  n=ltrim lcase z
  '
  'SKIP COMMAND
  '
  a=asc(n)
  b=1
  if a=34 then
    b=instr(2,n,qu)
    b+=1
  end if
  '
  '
  'CHECK FOR PARAMETER FOLLOWING
  '-----------------------------
  '
  a=instr(b,n," ")
  n=mid n,a+1
  n=ltrim(n)
  '
  'STRIP QUOTES ON FILENAME
  '------------------------
  '
  if asc(n)=34 then
    b=instr(2,n,qu)
    if b then n=mid n,2,b-2
  end if

  'print `filename  ` n

  if not a then
    print `error 1: missing filename`
    goto finish
    'WriteConsole consout, "please enter filename:  ",24,bufrit,0
    'ReadConsole consin,*bufin,100,bufrit,0
    'n=left bufin,bufrit
    'n=ltrim lcase n
    'if not len n then goto nfinish
  end if
  '
  n=ltrim n
  if not len(n) then
    print `error 2: missing filename`
    goto finish
  end if
  '
  'CHECK FOR .BAS EXTENSION NAME
  '-----------------------------
  '
  s=rtrim n 'accept any

  '
  'ATTEMPT TO GET FILE
  '-------------------
  '
  t=getfile s

  if not t then
    print `error 3: file empty or not found: ` s
    goto finish
  end if

  'NORMAL COMPILE
  '==============

  o2_asmo "#basic" cr t

  string e=o2_error

  if e then
    print "Error: " e
    goto finish
  else
    o2_exec
    goto xfinish
  end if

  
  finish:
  '------

  'ReadConsole consin,*bufin,len(bufin),bufrit,0


  xfinish:
  '-------
  