
  '=============================
  'OXYGEN BASIC STRING UTILITIES
  '=============================


  '12:44 20/02/2011
  '10:35 29/11/2011
  'Charles E V Pegge


  string cr=chr(13)+chr(10)
  string tab=chr(9)


  '------------------------------------
  sub skiplspace(s as string, i as sys)
  '====================================
  sys e=len s
  sys a
  do
    if i>e then exit do
    a=asc s,i
    if a>32 then exit do
  end do
  end sub

  '------------------------------------------------
  function getword(s as string, b as sys) as string
  '================================================
  'b=1
  sys a,c,d,bb,bc
  a=0
  bb=b
  do
    c=asc s,b
    if c=0 then exit do
    if c>32 then exit do
    b+=1
  end do
  bc=b
  do
    c=asc s,b
    if c<=32 then exit do
    if c=34 or c=96 then 'quotes
      do
        b+=1
        d=asc s,b
        if d=0 or d=c then b+=1 : jmp fwd done
      end do
    end if
    if c<48 then
      if c=35 then jmp fwd more '#
      if b=bc then b+=1
      exit do
    end if
    if c<58 then jmp fwd more 'numbers
    if c<64 then
      if b=bc then b+=1
      exit do
    end if
    if c<92 then jmp fwd more 'capitals and @
    if c<97 then
      if c=95 then jmp fwd more 'underscore
      if b=bc then b+=1
      exit do     
    end if
    if c<123 then jmp fwd more
    if c<128 then
      if b=bc then b+=1
      exit do     
    end if
    '
    'higher ascii chars treated as part of word
    '
    more:
    '
    b+=1 
  end do
  '
  done:
  '
  if b=bb then function="" else function=mid s,bb,b-bb
  end function

  '---------------------------------------
  function replace(string t,w,r) as string
  '=======================================
  '
  sys a,b,lw,lr
  string s=t
  '
  lw=len(w)
  lr=len(r)
  a=1
  '  
  do
    a=instr(a,s,w)
    if a=0 then exit do
    s=left(s,a-1)+r+mid(s,a+lw)
    a+=lr
  end do
  function=s
  end function


'Elastic String array

'----------------
class StringArray
'================

  protected
  sys en
  sys mx
  bstring list

  public


  method constructor()
  '===================
  end method


  method length(sys i) as sys
  '==========================
  if i>mx then return 0
  bstring * t : &t=?list
  if i>0 then return len t[i]
  end method


  method line(sys i, bstring s)
  '============================
  sys a
  if i>en then
    a=(i+4096-en)*sizeof sys
    en=4096+i
    list+=nuls a
  end if
  bstring * t : &t=?list
  if i>0 then
    t[i]=s
    if mx<i then mx=i
  end if
  end method


  method insert(sys i, bstring s)
  '==============================
  sys a,e,w
  if i>mx+1 then exit method
  w=sizeof sys
  mx+=1
  en+=1
  if i>0 then
    a=i*w-w 'strings below i
    list=left(list,a)+nuls(w)+mid(list,a+1) 'alter list of pointers only
    bstring * t : &t=?list
    'e=?list+a : *e=0 'nullify slot before assigning string
    t[i]=s
  end if
  end method


  method delete(sys i)
  '===================
  if en=0 then exit method
  if mx=0 then exit method
  if i>mx then exit method
  sys w=sizeof sys
  en-=1 : mx-=1
  if i>0 then
    sys a
    bstring * t : &t=?list
    'a=i*w-w+&t : frees *a
    a=?t[i] : frees a
    't[i]=""
    a=i*w-w
    list=left(list,a)+mid(list,a+w+1) 'alter list of pointers only
    mx-=1
  end if
  end method


  method line(sys i) as bstring
  '============================
  bstring * t : &t=?list
  if i>0 then
    if i<=mx then
      return t[i]
    end if
  end if
  end method


  method lines(string*s) as sys
  '============================
  sys i=0, a=1, b=1, et=0
  do
    b=instr a,s,cr
    if b=0 then
      b=len(s)+1 : et=1
      if b=1 then return 0
    end if
    i+=1 : line(i)=mid s,a,b-a
    if et then
      if a=b then i-=1 : mx-=1 'null line at end
      return i 'number of lines
    end if
    a=b+2
  end do
  end method  


  '-----------------------
  method LastLine() as sys
  '=======================
  return mx
  end method


  method locate(string w, sys *i,*j) as sys
  '========================================
  'case insensitive
  'returns linepos i and charpos j
  '
  sys e
  string s,k
  k=lcase w
  e=mx
  if i<1 then i=1
  if j<1 then j=1
  do
    if i>e then exit do
    s=lcase line(i)
    if len s then j=instr j,s,k else j=0
    if j then return i else j=1
    i+=1
  end do
  i=0 : j=0
  end method


  method clear()
  '=============
  sys i, q=?list
  for i=1 to mx
    frees *q : *q=0 : q+=sizeof sys
  next
  mx=0
  end method


  method destructor()
  '==================
  clear()
  frees ?list : ?list=0
  en=0
  end method

end class



'--------------
class TextArray
'==============

  has StringArray

  method load(string n) as sys
  '===========================
  sys i=0, a=1, b=1, et=0
  return lines getfile n
  end method  


  method save(string n) as sys
  '===========================
  sys i=1, la=1, ls, le, e
  string s="" : e=mx
  do
    if i>e then exit do
    le=length(i)+2
    if la+le>ls then
      s+=nuls le+0x10000 'add more space to buffer
      ls+=le+0x10000
    end if
    mid(s,la)=line(i)+cr
    la+=le
    i+=1
  end do
  putfile n,left s,la-1
  end method  

end class



