/*  Header 64 bit for OxygenBasic by Peter. Wirbelauer 28/11/2011   */

'ad-hoc definitions
typedef void OVERLAPPED, SECURITY_ATTRIBUTES


Type CREATESTRUCT
  lpCreateParams as sys
  hInstance      as sys
  hMenu          as sys
  hWndParent     as sys
  cy             as Long
  cx             as Long
  y              as Long
  x              as Long
  style          as Long
  lpszName       as zString ptr
  lpszClass      as zString ptr
  ExStyle        as Long
End Type

Type WNDCLASS
  Style         as long
  lpfnwndproc   as sys
  cbClsextra    as long
  cbWndExtra    as long
  hInstance     as sys
  hIcon         as sys
  hCursor       as sys
  hbrBackground as sys
  lpszMenuName  as sys
  lpszClassName as sys
End Type

Type XFORM
  eM11 as Single
  eM12 as Single
  eM21 as Single
  eM22 as Single
  eDx  as Single
  eDy  as Single
End Type

Type Size
  cx As Long
  cy As Long
End Type


Type POINTAPI
  x as long
  y as long
End Type

Type MSG
  hwnd    as sys
  message as long
  wParam  as sys
  lParam  as sys
  time    as long
  pt      as POINTAPI
End Type

Type RECT
  Left   as Long
  Top    as Long
  Right  as Long
  Bottom as Long
End Type

Type BITMAP
  bmType       as Long
  bmWidth      as Long
  bmHeight     as Long
  bmWidthBytes as Long
  bmPlanes     as short
  bmBitsPixel  as short
  bmBits       as sys
End Type

Type BLENDFUNCTION
  BlendOp             as Byte
  BlendFlags          as Byte
  SourceConstantAlpha as Byte
  AlphaFormat         as Byte
End Type

% GM_COMPATIBLE  = 1
% GM_ADVANCED    = 2
% MWT_IDENTITY   = 1
% MWT_LEFTMULTIPLY  = 2
% MWT_RIGHTMULTIPLY = 3
% MWT_MIN = 2
% MWT_MAX = 3

% MM_TEXT        = 1
% MM_LOMETRIC    = 2
% MM_HIMETRIC    = 3
% MM_LOENGLISH   = 4
% MM_HIENGLISH   = 5
% MM_TWIPS       = 6
% MM_ISOTROPIC   = 7
% MM_ANISOTROPIC = 8

% BN_CLICKED  = 0
% BN_HILITE   = 2
% BN_UNHILITE = 3
% BN_DBLCLK   = 5
% BN_PUSHED   = BN_HILITE
% BN_UNPUSHED = BN_UNHILITE

% GENERIC_WRITE  = 0x40000000
% GENERIC_READ   = 0x80000000
% FILE_SHARE_READ  = 1
% FILE_SHARE_WRITE = 2
% OPEN_EXISTING  = 3
% OPEN_ALWAYS    = 4

% IMAGE_BITMAP    = 0
% LR_LOADFROMFILE = 16
% AC_SRC_OVER     = 0
% AC_SRC_ALPHA    = 1
% DI_MASK         = 1
% DI_IMAGE        = 2
% DI_NORMAL       = DI_MASK Or DI_IMAGE

% SW_NORMAL      = 1
% SW_SHOWDEFAULT = 10
% SW_SHOW        = 5
% CS_VREDRAW     = 1
% CS_HREDRAW     = 2
% CS_OWNDC       = 32
% SM_CXSCREEN    = 0
% SM_CYSCREEN    = 1
% IDI_WINLOGO    = 32517
% IDC_ARROW      = 32512
% PS_SOLID       = 0
% DC_PEN         = 19

% WM_ERASEBKGND  = 20
% WM_CREATE      = 1
% WM_DESTROY     = 2
% WM_PAINT       = 15
% WM_QUIT        = 18
% WM_SIZE        = 5
% WM_MOVE        = 3
% WM_CHAR        = 258
% WM_KEYDOWN     = 256
% WM_KEYUP       = 257
% WM_MOUSEMOVE   = 512
% WM_MBUTTONDOWN = 519
% WM_LBUTTONDOWN = 513
% WM_RBUTTONDOWN = 516
% WM_LBUTTONUP   = 514
% WM_RBUTTONUP   = 517
% WM_MBUTTONUP   = 520
% WM_TIMER       = 275

% WS_OVERLAPPEDWINDOW = 0x00cf0000
% WS_SYSMENU    = 0x80000 
% WS_OVERLAPPED = WS_SYSMENU     
% WS_POPUP      = 0x80000000
% WS_DLGFRAME   = 0x400000
% WS_CHILD      = 0x40000000
% WS_VISIBLE    = 0x10000000

% PM_REMOVE      = 1
% PM_NOREMOVE    = 0
% NULL_BRUSH     = 5
% BLACKNESS      = 0x42
% WHITENESS      = 0xFF0062

Def w_1 0xCF0000
Def w_2 0x80000 
Def w_3 0x80000000
Def w_4 0x400000

Def FW_THIN       100
Def FW_EXTRALIGHT 200
Def FW_LIGHT      300
Def FW_NORMAL     400
Def FW_MEDIUM     500
Def FW_SEMIBOLD   600
Def FW_EXTRABOLD  800
Def FW_BOLD       700
Def FW_HEAVY      900

Def WHITE_BRUSH   0
Def BLACK_BRUSH   4

% vk_LBUTTON     = 0x01	
% vk_RBUTTON     = 0x02 
% vk_MBUTTON     = 0x04
% vk_BACK        = 0x08
% vk_TAB         = 0x09 
% vk_CLEAR       = 0x0C 
% vk_RETURN      = 0x0D 
% vk_SHIFT       = 0x10 
% vk_CONTROL     = 0x11 
% vk_MENU        = 0x12 
% vk_PAUSE       = 0x13 
% vk_CAPITAL     = 0x14 
% vk_ESCAPE      = 0x1B 
% vk_SPACE       = 0x20 
% vk_PRIOR       = 0x21 
% vk_NEXT        = 0x22 
% vk_END         = 0x23 
% vk_HOME        = 0x24 
% vk_LEFT        = 0x25 
% vk_UP          = 0x26 
% vk_RIGHT       = 0x27 
% vk_DOWN        = 0x28 
% vk_PRINT       = 0x2A 
% vk_SNAPSHOT    = 0x2C	 
% vk_INSERT      = 0x2D 
% vk_DELETE      = 0x2E 
% vk_HELP        = 0x2F 

% vk_0 = 0x30 
% vk_1 = 0x31 
% vk_2 = 0x32 
% vk_3 = 0x33 
% vk_4 = 0x34 
% vk_5 = 0x35
% vk_6 = 0H36 
% vk_7 = 0x37 
% vk_8 = 0x38 
% vk_9 = 0x39 
% vk_@ = 0x40
% vk_A = 0x41 
% vk_B = 0x42 
% vk_C = 0x43 
% vk_D = 0x44 
% vk_E = 0H45 
% vk_F = 0x46 
% vk_G = 0x47 
% vk_H = 0x48 
% vk_I = 0x49 
% vk_J = 0x4A 
% vk_K = 0x4B
% vk_L = 0x4C 
% vk_M = 0x4D 
% vk_N = 0x4E 
% vk_O = 0x4F 
% vk_P = 0x50 
% vk_Q = 0x51 
% vk_R = 0x52 
% vk_S = 0x53 
% vk_T = 0x54 
% vk_U = 0x55 
% vk_V = 0x56 
% vk_W = 0x57 
% vk_X = 0x58 
% vk_Y = 0x59 
% vk_Z = 0x5A 

% vk_F1  = 0x70 
% vk_F2  = 0x71 
% vk_F3  = 0x72 
% vk_F4  = 0x73 
% vk_F5  = 0x74 
% vk_F6  = 0x75 
% vk_F7  = 0x76 
% vk_F8  = 0x77 
% vk_F9  = 0x78 
% vk_F10 = 0x79 
% vk_F11 = 0x7A 
% vk_F12 = 0x7B 

% vk_LSHIFT   = 0xA0 
% vk_RSHIFT   = 0xA1 
% vk_LCONTR   = 0xA2	 
% vk_RCONTROL = 0xA3	

Def WHITE   0xFFFFFF
Def RED     0xOOOOFF
Def GREEN   0x00FF00
Def BLUE    0xFF0000
Def YELLOW  0x00FFFF
Def MAGENTA 0xFF00FF
Def CYAN    0xFFFF00
Def B_RED   0x8080FF
Def B_GREEN 0x80FF80
Def b_BLUE  0xFF8080

sys kernel32,user32,gdi32
kernel32 = LoadLibrary "kernel32.dll"
user32   = LoadLibrary "user32.dll"
gdi32    = LoadLibrary "gdi32.dll"

Bind kernel32
(
  GetCommandLine  GetCommandLineA   
  GetModuleHandle GetModuleHandleA  
  ExitProcess     ExitProcess
  sleep           Sleep
  Beep            Beep    
)  

Bind user32
(
  LoadIcon         LoadIconA        
  LoadCursor       LoadCursorA       
  RegisterClass    RegisterClassA    
  MessageBox       MessageBoxA       
  SendMessage      SendMessageA 
  GetMessage       GetMessageA 
  PeekMessage      PeekMessageA
  TranslateMessage TranslateMessage 
  DispatchMessage  DispatchMessageA 
  PostQuitMessage  PostQuitMessage  
  PostMessage      PostMessageA
  CreateWindowEx   CreateWindowExA   
  ShowWindow       ShowWindow        
  UpdateWindow     UpdateWindow      
  DefWindowProc    DefWindowProcA
  InvalidateRect   InvalidateRect
  ValidateRect     ValidateRect
  GetSystemMetrics GetSystemMetrics 
  ReleaseDC        ReleaseDC
  GetDC            GetDC
  ShowCursor       ShowCursor
)
 
Bind gdi32
(
  GetStockObject   GetStockObject
  CreateSolidBrush CreateSolidBrush
  SetBkMode        SetBkMode
  SetBkColor       SetBkColor
  SetDCPenColor    SetDCPenColor
  SetDCBrushColor  SetDCBrushColor
)

Declare Sub      ZeroMemory        Lib "kernel32.dll" Alias "RtlZeroMemory" (ByRef Destination As Any, ByVal Length As sys)
Declare Sub      CopyMemory        Lib "kernel32.dll" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal Length As sys)
Declare Function DrawIconEx        Lib "user32.dll" (ByVal hdc As sys, ByVal xLeft As Long, ByVal yTop As Long, ByVal hIcon As Long, ByVal cxWidth As Long, ByVal cyWidth As Long, ByVal istepIfAniCur As long, ByVal hbrFlickerFreeDraw As sys, ByVal diFlags As Long) As long
Declare Function AlphaBlend        Lib "msimg32.dll" (ByVal hdcDest As sys, ByVal xDest As Long, ByVal yDest As Long, ByVal WidthDest As Long, ByVal HeightDest As Long, ByVal hdcSrc As sys, ByVal xSrc As Long, ByVal ySrc As Long, ByVal WidthSrc As Long, ByVal HeightSrc As Long, ByVal Blendfunc As Long) As Long
Declare Function Rectangle         Lib "gdi32.dll" Alias "Rectangle" (ByVal hdc As sys, ByVal x1 As Long, ByVal y1 As Long, ByVal x2 As Long, ByVal y2 As Long) As Long
Declare Function MoveToEx          Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByRef lpPoint As POINTAPI) As Long
Declare Function Ellipse           Lib "gdi32.dll" (ByVal hdc As sys, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long
Declare Function LineTo            Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long) As Long
Declare Function CreatePen         Lib "gdi32.dll" (ByVal nPenStyle As Long, ByVal nWidth As Long, ByVal crColor As Long) As Long
Declare Function RoundRect         Lib "gdi32.dll" (ByVal hdc As sys, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long) As Long
Declare Function Arc               Lib "gdi32.dll" (ByVal hdc As sys, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long, ByVal X3 As Long, ByVal Y3 As Long, ByVal X4 As Long, ByVal Y4 As Long) As Long
Declare Function PolyBezier        Lib "gdi32.dll" (ByVal hdc As sys, ByRef lppt As POINTAPI, ByVal cPoints As Long) As Long
Declare Function Polyline          Lib "gdi32.dll" (ByVal hdc As sys, ByRef lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function Polygon           Lib "gdi32.dll" (ByVal hdc As sys, ByRef lpPoint As POINTAPI, ByVal nCount As Long) As Long
Declare Function GetClientRect     Lib "user32.dll" (ByVal hwnd As sys, ByRef lpRect As RECT) As Long
Declare Function StretchBlt        Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As sys, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal dwRop As Long) As Long
Declare Function FillRect          Lib "user32.dll" (ByVal hdc As sys, ByRef lpRect As RECT, ByVal hBrush As sys) As Long
Declare Function SetPixelV         Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Declare Function SetPixel          Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByVal crColor As Long) As Long
Declare Function GetPixel          Lib "gdi32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long) As Long
Declare Function TextOut           Lib "gdi32.dll" Alias "TextOutA" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Declare Function DeleteDC          Lib "gdi32.dll" (ByVal hdc As sys) As Long
Declare Function PlayWav           Lib "winmm.dll" Alias "PlaySoundA" (ByVal lpszName As String, ByVal hModule As sys, ByVal dwFlags As Long) As Long
Declare Function CreateFont        Lib "gdi32.dll" Alias "CreateFontA" (ByVal H As Long, ByVal W As Long, ByVal E As Long, ByVal O As Long, ByVal W As Long, ByVal I As Long, ByVal u As Long, ByVal S As Long, ByVal C As Long, ByVal OP As Long, ByVal CP As Long, ByVal Q As Long, ByVal PAF As Long, ByVal F As String) As sys
Declare Function SetCursorPos      Lib "user32.dll" (ByVal x As Long, ByVal y As Long) As Long
Declare Function GetFileSize       Lib "kernel32.dll" (ByVal hFile As sys, ByRef lpFileSizeHigh As Long) As Long
Declare Function ReadFile          Lib "kernel32.dll" (ByVal hFile As sys, ByRef lpBuffer As Any, ByVal nNumberOfBytesToRead As Long, ByRef lpNumberOfBytesRead As Long, ByRef lpOverlapped As OVERLAPPED) As Long
Declare Function WriteFile         Lib "kernel32.dll" (ByVal hFile As sys, ByRef lpBuffer As Any, ByVal nNumberOfBytesToWrite As Long, ByRef lpNumberOfBytesWritten As Long, ByRef lpOverlapped As OVERLAPPED) As Long
Declare Function CloseHandle       Lib "kernel32.dll" (ByVal hObject As sys) As Long
Declare Function CreateFile        Lib "kernel32.dll" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByRef lpSecurityAttributes As SECURITY_ATTRIBUTES, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As sys
Declare Function DeleteFile        Lib "kernel32.dll" Alias "DeleteFileA" (ByVal lpFileName As String) As Long
Declare Function timeGetTime       Lib "winmm.dll" () As Long
Declare Function DestroyWindow     Lib "user32.dll" (ByVal hwnd As sys) As Long
Declare Function SelectObject      Lib "gdi32.dll" (ByVal hdc As sys, ByVal hObject As sys) As Long
Declare Function DeleteObject      Lib "gdi32.dll" (ByVal hObject As sys) As Long
Declare Function GetObject         Lib "gdi32.dll" Alias "GetObjectA" (ByVal hObject As sys, ByVal nCount As Long, ByRef lpObject As Any) As long
Declare Function SetTextColor      Lib "gdi32.dll" (ByVal hdc As sys, ByVal crColor As Long) As Long
Declare Function GetTickCount      Lib "kernel32.dll" () As Long
Declare Function SetWindowText     Lib "user32.dll" Alias "SetWindowTextA" (ByVal hwnd As sys, ByVal lpString As String) As Long
Declare Function TransparentBlt    Lib "msimg32.dll" (ByVal hdc As sys, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As sys, ByVal xSrc As Long, ByVal ySrc As Long, ByVal nSrcWidth As Long, ByVal nSrcHeight As Long, ByVal crTransparent As Long) As Long
Declare Function LoadImage         Lib "user32.dll" Alias "LoadImageA" (ByVal hInst As sys,ByVal lpsz As String,ByVal un1 As Long,ByVal n1 As Long, ByVal n2 As Long, ByVal un2 As Long) As sys
Declare Function BitBlt            Lib "gdi32.dll" (ByVal hDestDC As sys, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As sys, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long
Declare Function PlgBlt            Lib "gdi32.dll" (ByVal hdcDest As sys, ByRef lpPoint As POINTAPI, ByVal hdcSrc As sys, ByVal nXSrc As Long, ByVal nYSrc As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hbmMask As sys, ByVal xMask As Long, ByVal yMask As Long) As Long
Declare Function UnregisterClass   Lib "user32.dll" Alias "UnregisterClassA" (ByVal lpClassName As String, ByVal hInstance As sys) As Long
Declare Function CreateSolidBrush  Lib "gdi32.dll" (ByVal crColor As Long) As sys
Declare Function GetAsyncKeyState  Lib "user32.dll" (ByVal vKey As Long) As Short
Declare Function SetStretchBltMode Lib "gdi32.dll" (ByVal hdc As sys, ByVal nStretchMode As Long) As Long
Declare Function SetWorldTransform Lib "gdi32.dll" (ByVal hdc As sys, ByRef lpXform As xform) As Long
Declare Function SetMapMode        Lib "gdi32.dll" (ByVal hdc As sys, ByVal nMapMode As Long) As Long
Declare Function SetGraphicsMode   Lib "gdi32.dll" (ByVal hdc As sys, ByVal iMode As Long) As Long
Declare Function SetWindowExtEx    Lib "gdi32.dll" (ByVal hdc As sys, ByVal nX As Long, ByVal nY As Long, ByRef lpSize As SIZE) As Long
Declare Function SetWindowOrgEx    Lib "gdi32.dll" (ByVal hdc As sys, ByVal nX As Long, ByVal nY As Long, ByRef lpPoint As POINTAPI) As Long
Declare Function SetViewportExtEx  Lib "gdi32.dll" (ByVal hdc As sys, ByVal nX As Long, ByVal nY As Long, ByRef lpSize As SIZE) As Long
Declare Function GetStdHandle      Lib "kernel32.dll" (ByVal nStdHandle As Long) As sys
Declare Function SetStdHandle      Lib "kernel32.dll" (ByVal nStdHandle As Long, ByVal hHandle As sys) As Long
Declare Function ColorHLSToRGB     Lib "shlwapi.dll" (ByVal wHue As Integer, ByVal wLuminance As Integer, ByVal wSaturation As Integer) As Long
Declare Sub      ColorRGBToHLS     Lib "shlwapi.dll" (ByVal clrRGB As Long, ByRef pwHue As Integer, ByRef pwLuminance As Integer, ByRef pwSaturation As Integer)
Declare Function ModifyWorldTransform  Lib "gdi32.dll" (ByVal hdc As sys, ByRef lpXform As xform, ByVal iMode As Long) As Long
Declare Function CreateCompatibleDC    Lib "gdi32.dll" (ByVal hdc As sys) As sys
Declare Function SetForegroundWindow   Lib "user32.dll" (ByVal hwnd As sys) As Long
Declare Function CreateCompatibleBitmap Lib "gdi32.dll" (ByVal hdc As sys, ByVal nWidth As Long, ByVal nHeight As Long) As sys
Declare Function QueryPerformanceCounter Lib "kernel32.dll" (ByRef lpPerformanceCount As quad) As Long
Declare Function QueryPerformanceFrequency Lib "kernel32.dll" (ByRef lpFrequency As quad) As Long

Type TRGB
  r As sys
  g As sys
  b As sys
End Type

Type THLS
  h As Integer
  l As Integer
  s As Integer
End Type

Dim cHLS   As THLS
Dim cRGB   As TRGB
Dim info   As BITMAP
Dim wm     As MSG
Dim wc     As WNDCLASS 
Dim rc     As RECT
Dim mForm  As XFORM
Dim Blend  As BLENDFUNCTION
Dim pt     As POINTAPI

Dim BmpWidth (512) as sys
Dim BmpHeight(512) as sys
Dim iHnd(512)      as sys
Dim iHdc(512)      as sys
Dim THdc(512)      as sys
Dim THnd(512)      as sys    
Dim TWidth (512)   as sys
Dim THeight(512)   as sys
Dim FHdc(512)      as sys
Dim FHnd(512)      as sys
Dim FWidth (512)   as sys
Dim FHeight(512)   as sys

Dim sys_Seed  as sys
Dim sys_hdc   as sys
Dim sys_hwnd  as sys
Dim sys_xPos  as sys
Dim sys_yPos  as sys
Dim AscKey    as sys
Dim sys_color as sys
Dim xMouse    as sys
Dim yMouse    as sys
Dim WinExit   as sys
Dim dwc as sys

Quad sys_cT1,sys_cT2,sys_Freq                                                               
Quad sys_qc1,sys_qc2,sys_qf
Double sys_Interval               
sys sys_fjs,sys_Frames,sys_zs,width,height,bHnd,bHdc,sys_mode=3,MouseButton,sHdc,sHnd,ShapeWidth,ShapeHeight,TmpH,TmpW,TmpP 
sys hButton

Function HiWord (sys hi) as sys
shr hi,16
Return hi
End Function

Function LoWord (sys lo) as sys
and lo,0xFFFF 
Return lo
End Function

Function LoadFile(File As String, byref dest As Any) As Long
sys fHandle
Long count
fHandle = CreateFile(file, GENERIC_WRITE or GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, BYVAL 0, OPEN_ALWAYS, 0, 0) 
count   = GetFileSize fHandle, Byval 0
ReadFile fHandle,dest,count,dwc,Byval 0
CloseHandle fHandle
Return dwc
End Function

Sub SaveFile(File as string,byref dest As Any, byval count As Long)   
sys fHandle
fHandle = CreateFile(file, GENERIC_WRITE or GENERIC_READ, FILE_SHARE_READ Or FILE_SHARE_WRITE, BYVAL 0, OPEN_ALWAYS, 0, 0) 
WriteFile fHandle,dest,count,&dwc,Byval 0
CloseHandle fHandle
End Sub

Sub WinEnd()             
sys jx
For jx=0 To 512
iF iHdc(jx) >0 
   DeleteObject iHnd(jx)
   DeleteDC     iHdc(jx)
EndiF
Next
For jx=0 To 512
iF THdc(jx) >0 
   DeleteObject THnd(jx)
   DeleteDC     THdc(jx)
EndiF
Next
For jx=0 To 512
iF FHdc(jx) >0 
   DeleteObject FHnd(jx)
   DeleteDC     FHdc(jx)
EndiF
Next
DestroyWindow sys_hwnd  
ReleaseDC sys_hwnd, sys_hdc
DeleteObject bHnd
DeleteDC     bHdc
End Sub

Sub ColorKey(sys red, green, blue)
sys_color = red + green*256 + blue*65536  
End Sub

Function LoadBmp(string File, sys Frames) as sys
static id as sys
iF id <512 Then id +=1
iHnd(id) = LoadImage(0,File + ".bmp",0,0,0,16)
iHdc(id) = CreateCompatibleDC(sys_hdc)
SelectObject iHdc(id), iHnd(id)
GetObject iHnd(id), sizeof info, &info
BmpWidth (id) = info.bmWidth /Frames 
BmpHeight(id) = info.bmHeight         
Return id
End Function        

Sub SetBmp(int id, x1, y1, zx, zy, zF)
TransparentBlt bHdc,x1,y1,zx,zy,iHdc(id),BmpWidth(id)*zF,0,BmpWidth(id),BmpHeight(id),sys_color 
End Sub

Function LoadBmpFont(string File) as sys
Static id as sys
iF id <512 Then id +=1
FHnd(id) = LoadImage(0,File + ".bmp",0,0,0,16)
FHdc(id) = CreateCompatibleDC(sys_hdc)
SelectObject FHdc(id), FHnd(id)
GetObject FHnd(id), sizeof info, &info
FWidth (id)= info.bmWidth /16
FHeight(id)= info.bmHeight/6
Return id
End Function

Sub BmpText(sys id, string txt, sys tx, ty, zx, zy) 
sys sx ,rx, ry
For sx=1 To Len(txt)
   rx = Asc(txt, sx)
   iF rx >=32 and rx <=127 
      rx = rx-32
   iF rx >=16 and rx <=31 
      ry=1: rx -=16
   ElseiF rx >=32 and rx <=47
      ry=2: rx -=32
   ElseiF rx >=48 and rx <=63 
      ry=3: rx -=48
   ElseiF rx >=64 and rx <=79 
      ry=4: rx -=64
   ElseiF rx >=80 and rx <=97 
      ry=5: rx -=80
  Else 
      ry =0
  End iF 
  TransparentBlt bHdc,tx,ty,zx,zy,FHdc(id), FWidth(id)*rx, FHeight(id)*ry, FWidth(id), FHeight(id),sys_color 
  tx = tx + zx
  End iF
Next 
End Sub

Function LoadTile(string File, sys xFrame,yFrame) as sys
static id as sys
iF id <512 Then id +=1
THnd(id) = LoadImage(0,File + ".bmp",0,0,0,16)
THdc(id) = CreateCompatibleDC(sys_hdc)
SelectObject THdc(id), THnd(id)
GetObject THnd(id), sizeof info, &info
TWidth (id) = info.bmWidth /xFrame
THeight(id) = info.bmHeight/yFrame         
Return id
End Function        

Sub SetTile(sys id, x1, y1, zx, zy, xF, yF)
TransparentBlt bHdc, x1,y1, zx,zy, THdc(id), TWidth(id)*xF,THeight(id)*yF, TWidth(id),THeight(id), sys_color 
End Sub

Sub Font(sys width, height, flag, string font)  
sys hFont
hFont = CreateFont height,width,0,0,flag,0,0,0,0,0,0,0,0,font
SelectObject bHdc, hFont
SetBkMode bHdc,1
DeleteObject hFont
End Sub

Sub Text(string txt, sys x, y, color) 
SetTextColor bHdc, color
TextOut bHdc,x,y,txt,Len(txt)
End Sub

Sub SwapBuffers()
GetClientRect sys_hWnd, rc
SetStretchBltMode sys_hdc,sys_mode  
StretchBlt sys_hdc, 0, 0, rc.right, rc.bottom, bHdc, 0, 0, width, height, 0xCC0020
End Sub

Sub Cls( sys color)
sys iBrush = CreateSolidBrush color
SelectObject bHdc, iBrush
Rectangle bHdc, 0, 0, width, height
DeleteObject iBrush
End Sub

Function WndProc(byval hWnd as sys,byval wMsg as sys, byval wParam as sys,byval lparam as sys) as sys callback
iF wMsg = WM_CREATE
'
ElseiF wMsg = WM_PAINT
'
ElseiF wMsg = WM_SIZE
SwapBuffers
'
ElseiF wMsg = WM_MOVE 
SwapBuffers
ValidateRect sys_hwnd,0
'
ElseiF wMsg = WM_MOUSEMOVE
xMouse = LoWord(lParam)
yMouse = HiWord(lParam)
InValidateRect sys_hwnd,0,0
'
ElseiF wMsg = WM_LBUTTONDOWN
MouseButton =1
InvalidateRect hWnd,0,0 
ElseiF wMsg = WM_LBUTTONUP
MouseButton =0  
InvalidateRect hWnd,0,0 
ElseiF wMsg = WM_RBUTTONDOWN
MouseButton =2
InvalidateRect hWnd,0,0 
ElseiF wMsg = WM_RBUTTONUP
MouseButton =0
InvalidateRect hWnd,0,0
ElseiF wMsg = WM_MBUTTONDOWN
MouseButton =4
InvalidateRect hWnd,0,0 
ElseiF wMsg = WM_MBUTTONUP
MouseButton =0
InvalidateRect hWnd,0,0
'
ElseiF wMsg = WM_CHAR
AscKey = wParam
InvalidateRect hWnd,0,0
'
ElseiF wMsg = WM_KEYUP
AscKey =0
InvalidateRect hWnd,0,0
'
ElseiF wMsg = WM_DESTROY
WinEnd
PostQuitMessage 0
Else
Function = DefWindowProc hWnd,wMsg,wParam,lParam
End iF
End Function

Sub DoEvents()
iF PeekMessage (&wm,0,0,0,Pm_Remove) >0
iF wm.message = Wm_Quit Then WinExit=1 
TranslateMessage &wm
DispatchMessage  &wm
End iF
End Sub

Function SetWindow (string caption, sys Ww, Wh, style) as sys
sys inst, Wx, Wy, Scr
inst = GetModuleHandle 0
wc.style = CS_HREDRAW or CS_VREDRAW or CS_OWNDC 
wc.lpfnWndProc = &WndProc
wc.cbClsExtra =0
wc.cbWndExtra =0
wc.hInstance  = inst
wc.hIcon=LoadIcon 0,IDI_WINLOGO            
wc.hCursor=LoadCursor 0,IDC_ARROW       
wc.hbrBackground = 0 
wc.lpszMenuName  = ?0
wc.lpszClassName = @"Oxygen"
RegisterClass &wc
Scr = GetSystemMetrics SM_CXSCREEN
Wx  = (Scr - Ww) /2
Scr = GetSystemMetrics SM_CYSCREEN
Wy  = (Scr - Wh) /2
sys_hwnd = CreateWindowEx 0, wc.lpszClassName, caption, style, Wx, Wy, Ww, Wh, 0, 0, inst, 0
ShowWindow sys_hwnd,SW_SHOW 
sys_hdc = GetDC(sys_hwnd)
GetClientRect sys_hwnd, rc
bHnd = CreateCompatibleBitmap(sys_hdc, rc.right, rc.bottom)
bHdc = CreateCompatibleDC(sys_hdc)
SelectObject bHdc, bHnd
Width = rc.right: Height = rc.bottom
sys_Seed = timeGetTime
QueryPerformanceFrequency sys_qf
QueryPerformanceCounter   sys_qc1
Return sys_hwnd
End Function

Sub WaitKey(sys Key)
    While GetAsyncKeyState(Key)=0
    iF WinExit=1
       WinEnd
       ExitProcess 0
    End iF
    DoEvents
    SwapBuffers
    Wend
    While GetAsyncKeyState(Key)<0
       DoEvents
       SwapBuffers
    Wend
    Return 1
End Sub    

Function RGB(sys red, green, blue) as sys
    Return red + green*256 + blue*65536
End Function

Function HLS(integer hue, lum, sat) as sys
    Return ColorHLSToRGB hue,lum,sat 
End Function

Sub GetRGB(sys c) 
    cRGB.r = c & 0xFF           
    cRGB.g = (c >>  8) & 0xFF   
    cRGB.b = (c >> 16) & 0xFF   
End Sub

Sub GetHLS(sys col)
    colorRGBtoHLS col,cHLS.h,cHLS.l,cHLS.s 
End Sub    

Sub Randomize()
sys_Seed = timeGetTime
End Sub

Function Rand(sys z1, z2) as sys
sys   rnd 
mov   eax,z2
sub   eax,z1
inc   eax
imul  edx,sys_Seed,0x8088405
inc   edx
mov   sys_Seed,edx
mul   edx
add   edx,z1
mov   rnd,edx
Return rnd
End Function 

Sub SetBlend(int id, x, y, zx, zy, alfa)
AlphaBlend bHdc,x,y,zx,zy,iHdc(id),0,0,bmpWidth(id),bmpHeight(id), 0x10000*alfa 
End Sub

Sub Oval(int x,y,ra,rb,c)
sys iBrush
iBrush = CreateSolidBrush c
SelectObject bHdc, iBrush
Ellipse bHdc,x,y,ra+x,rb+y
DeleteObject iBrush
End Sub

Sub Line(int x,y,a,b,w,c)
sys iPen,hPen
iPen = CreatePen PS_SOLID,w,c
SelectObject bHdc, iPen
MoveToEx bHdc,x,y,Byval 0
LineTo bHdc,a,b
DeleteObject iPen
hPen = GetStockObject(DC_PEN)
SelectObject bHdc, hPen
End Sub

Sub Poke(int x, y, c)
SetpixelV (bHdc, x, y, c)
End Sub

Sub Peek(int x, y) 
Return GetPixel (bHdc, x, y)
End Sub

Sub RoundBox(int x,y,w,h,r1,r2,c)  
sys iBrush
iBrush = CreateSolidBrush c
SelectObject bHdc, iBrush
RoundRect bHdc,x,y,w+x,h+y,r1,r2
DeleteObject iBrush
End Sub

Sub FillBox(int x,y,w,h,c)  
sys iBrush
iBrush = CreateSolidBrush c
SelectObject bHdc, iBrush
Rectangle bHdc,x,y,w+x,h+y
DeleteObject iBrush
End Sub

Sub Box(int x, y, w, h, t, c)
Line x, y, x+w, y, t,c
Line x,y+h,x+w,y+h,t,c
Line x, y, x, y+h, t,c
Line x+w,y,x+w,y+h,t,c
End Sub

Sub Circle(int xj, yj, r, col)
int f=1-r, ry= -2*r, rx, y=r, x
poke xj, yj + r, col
Poke xj, yj - r, col
Poke xj + r, yj, col
Poke xj - r, yj, col
While x < y 
iF f >= 0 
   y -= 1
   ry +=2
   f  +=ry
End iF
x  += 1
rx += 2
f  += rx + 1
Poke  xj + x, yj + y, col
Poke  xj - x, yj + y, col
Poke  xj + x, yj - y, col
Poke  xj - x, yj - y, col
Poke  xj + y, yj + x, col
Poke  xj - y, yj + x, col
Poke  xj + y, yj - x, col
Poke  xj - y, yj - x, col
Wend
End Sub

Function Key(sys cKey) As sys
    Return GetAsyncKeyState(cKey)
End Function

Function EscKey() As sys
iF WinExit=1 
   WinEnd
   ExitProcess 0
End iF
Return GetAsyncKeyState(27)
End Function

Sub ShowMouse(sys mouse)   
ShowCursor(mouse)
End Sub                

Sub SetMouse(sys mmx, mmy)
SetCursorPos mmx, mmy
End Sub

Sub FrameRate(sys Frame)    
QueryPerformanceFrequency sys_Freq                                                                                          
sys_Interval = sys_Freq/Frame  
While (1)                                                                       
QueryPerformanceCounter sys_cT2                                                 
iF sys_cT2 >= sys_cT1 + sys_Interval                                             
   QueryPerformanceCounter sys_cT1                                              
   Exit Sub            
End iF
Wend                                                                             
End Sub

Function ShowFrames() as sys 
QueryPerformanceCounter sys_qc2
iF sys_qc2 - sys_qc1 > sys_qf             
   sys_fjs = sys_Frames
   sys_Frames =0
   sys_qc1 += sys_qf                         
End iF
sys_Frames +=1
Function = sys_fjs
End Function




