
  include "..\..\inc\MinWin.inc"


 
  Declare Function Rectangle Lib "gdi32.dll" (ByVal hdc as long, ByVal X1 as long, ByVal Y1 as long, ByVal X2 as long, ByVal Y2 as long) as long
  Declare Function Ellipse Lib   "gdi32.dll" (ByVal hdc as long, ByVal X1 as long, ByVal Y1 as long, ByVal X2 as long, ByVal Y2 as long) as long



  % ID_Timer            3000
  % Interval            100


 '-----------
  'SHARED DATA
  '===========
  '
  sys dat[256] 'shared data
  sys active   'window thread active


  '--------------------------------------------------------------------------------------------------------------------------
  function WndProc (  byval hWnd as long,  byval wMsg as long, byval wParam as long,  byval lparam as long ) as long callback
  '==========================================================================================================================

  static as Long d,count=0, refreshes=0, hdc
  static as String txt
  static as PaintStruct Paintst
  static as sys xmax, ymax, r, idx, idy, xball, yball
  static as rect crect 'for WndProc and TimerProc
 
    '==========
    select wMsg
    '==========
        
      '--------------
      case WM_CREATE
      '=============

      hTimer = SetTimer hWnd, ID_Timer, Interval, 0
      GetClientRect  hWnd,&cRect
      '
      r=15 : idx=5 : idy=5 : xball=200 : yball=100 : d=1  

      '--------------
      case WM_TIMER
      '=============

      if r=50 then d=-1
      if r=10 then d=1
      r+=d
      if dat=1
        xball=dat[11] : yball=dat[12] 'itr x,y<=dat[11]
      elseif dat=2
        SendMessage hwnd, WM_DESTROY, 0, 0
      end if
      '
      if dat<>2 then InvalidateRect hwnd,&crect,1
      '
      dat=0 'clear flag

      '--------------  
      case WM_DESTROY
      '===============
      '
      KillTimer(hWnd,ID_TIMER)
      PostQuitMessage 0
        
      '------------
      case WM_PAINT
      '============

      'TEXT
      'http://msdn.microsoft.com/en-us/library/dd144821(v=VS.85).aspx

      'DRAWING AND PAINTING
      'http://msdn.microsoft.com/en-us/library/dd162760(v=VS.85).aspx


      hDC=BeginPaint hWnd,&Paintst
      GetClientRect  hWnd,&cRect
      'style
      '0x20 DT_SINGLELINE
      '0x04 DT_VCENTER
      '0x01 DT_CENTER
      '0x25

       SetBkColor   hdc,yellow
       SetTextColor hdc,red
       txt="x y pos" str(xball) " , " str(yball)
       'print txt
       'DrawText hDC,"Hello World",-1,&cRect,0x25
       DrawText hDC,*txt,-1,&cRect,0x25
       refreshes+=1
       Ellipse hdc, xball-r, yball-r, xball+r, yball+r
       'Ellipse hdc, xball, yball, xball+20, yball+30
       EndPaint hWnd,&Paintst
       ValidateRect hwnd,&crect 
        
      '--------------   
      case WM_KEYDOWN
      '==============

      '============            
      Select wParam
      '============

	Case 37 : xball -= idx   'LEFT
        Case 39 : xball += idx   'RIGHT
        Case 38 : yball -= idy   'UP
	Case 40 : yball += idy   'DOWN
	Case 32 : Rectangle hdc, -1, -1, xmax+1, ymax+1 'SPACE
	Case 27 : SendMessage hwnd, WM_CLOSE, 0, 0      'ESCAPE

       End Select
       '
       InvalidateRect hwnd, &cRect, 1 'FULL SCREEN REFRESH

      '--------        
      case else
      '========
          
        function=DefWindowProc hWnd,wMsg,wParam,lParam
        
    end select

  end function ' WndProc


  '--------------------------------------------------------------------------------------------------------------
  Function WinMain(byval inst as long,byval prevInst as long,byval cmdline as asciiz, byval show as long) as long
  '==============================================================================================================

  WndClass wc
  MSG      wm

  sys hwnd, wwd, wht, wtx, wty, tax

  wc.style = CS_HREDRAW or CS_VREDRAW
  wc.lpfnWndProc = &WndProc 
  wc.cbClsExtra =0
  wc.cbWndExtra =0    
  wc.hInstance =inst
  wc.hIcon=LoadIcon 0, IDI_APPLICATION
  wc.hCursor=LoadCursor 0,IDC_ARROW
  wc.hbrBackground = GetStockObject WHITE_BRUSH 
  wc.lpszMenuName =0
  wc.lpszClassName =@"Demo"

  RegisterClass (&wc)
 
  Wwd = 800 : Wht = 600
  Tax = GetSystemMetrics SM_CXSCREEN
  Wtx = (Tax - Wwd) /2
  Tax = GetSystemMetrics SM_CYSCREEN
  Wty = (Tax - Wht) /2
 
  hwnd = CreateWindowEx 0,wc.lpszClassName,"OXYGEN BASIC",WS_OVERLAPPEDWINDOW,Wtx,Wty,Wwd,Wht,0,0,inst,0
  ShowWindow hwnd,SW_SHOW
  UpdateWindow hwnd
  '
  sys bRet
  '
  do while bRet := GetMessage (&wm, 0, 0, 0)
    if bRet = -1 then
      'show an error message
      exit while
    else
      TranslateMessage &wm
      DispatchMessage &wm
    end if
  wend

  End Function 



  include "..\..\inc\StartWin.inc"
